"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class BreakPoint(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "coordinates",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_6 import reports as reports_6_9_0

        return {
            "coordinates": reports_6_9_0.Coordinates,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_6 import reports as reports_6_9_0

        return {
            "org.gel.models.report.avro.Coordinates": reports_6_9_0.Coordinates,
            "org.gel.models.report.avro.BreakPoint": reports_6_9_0.BreakPoint,
        }

    __slots__ = [
        "coordinates",
        "alternate",
        "info",
        "reference",
    ]

    def __init__(
        self,
        coordinates,
        alternate=None,
        info=None,
        reference=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_9_0.BreakPoint model.

        :param coordinates:
        :type coordinates: Coordinates
        :param alternate:
        :type alternate: None | str
        :param info:
        :type info: None | dict[str, str]
        :param reference:
        :type reference: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.9.0"
